apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if do_backups | default(False) %}
    backups.opsperator.io/driver: etcd
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: "{{ etcd_name if (etcd_tls | default(False)) else False }}"
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ etcd_name }}
  name: {{ etcd_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ etcd_replicas }}
  selector:
    matchLabels:
      name: {{ etcd_name }}
  serviceName: {{ etcd_name }}
  template:
    metadata:
      labels:
        name: {{ etcd_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ etcd_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ etcd_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - command:
        - "/bin/sh"
        - "-ecx"
        - |
          IP=$(hostname -i)
          DOMAIN=$(hostname -d)
          PEERS=""
          for i in $(seq 0 $((${CLUSTER_SIZE} - 1))); do
              PEERS="$PEERS${PEERS:+,}$SET_NAME-$i=http://$SET_NAME-$i.$DOMAIN:2380"
          done
          exec etcd --name $HOSTNAME \
            --listen-peer-urls http://$IP:2380 \
            --listen-client-urls http://$IP:2379,http://127.0.0.1:2379 \
            --advertise-client-urls http://$HOSTNAME.$DOMAIN:2379 \
            --initial-advertise-peer-urls http://$HOSTNAME.$DOMAIN:2380 \
            --initial-cluster-token $CLUSTER_TOKEN \
            --initial-cluster $PEERS \
            --initial-cluster-state new \
            --data-dir /var/run/etcd/default.etcd
        env:
        - name: CLUSTER_SIZE
          value: "{{ etcd_replicas }}"
        - name: CLUSTER_TOKEN
          value: {{ etcd_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: SET_NAME
          value: {{ etcd_name }}
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='etcd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 2379
          timeoutSeconds: 3
        name: etcd
        ports:
        - containerPort: 2379
          name: client
        - containerPort: 2380
          name: peer
        readinessProbe:
          initialDelaySeconds: 10
          periodSeconds: 10
          tcpSocket:
            port: 2379
          timeoutSeconds: 2
        resources:
          limits:
            cpu: "{{ etcd_cpu_limit }}"
            memory: "{{ etcd_memory_limit }}"
          requests:
            cpu: "{{ etcd_cpu_limit }}"
            memory: "{{ etcd_memory_limit }}"
        volumeMounts:
        - mountPath: /var/run/etcd
          name: data
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ etcd_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ etcd_data_volume_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
